import { AnyHtmlElement, Segment, SelectionRange, String12hr, String24hr, TimeObject } from '../../types/index';
export interface ExtendedTimeObject extends TimeObject {
    timeObject: TimeObject;
}
export declare type GetString12hr = (string12hr: String12hr) => ExtendedTimeObject;
export declare type GetString24hr = (string24hr: String24hr) => ExtendedTimeObject;
export declare type ProvideTimeString = (timeString: String12hr | String24hr) => {
    as24hr: () => String24hr;
    as12hr: () => String12hr;
};
export declare type GetInputValue = ($input: HTMLInputElement | null) => {
    as12hrString: () => String12hr;
    as24hrString: () => String24hr;
    asTimeObject: () => TimeObject;
};
export declare type GetLabelTextOf = ($input: HTMLInputElement | null, document?: Document) => string;
export declare type GetCursorSegment = ($input: HTMLInputElement | null) => Segment;
export declare type GetNextPrevSegment = ($inputOrSegment: HTMLInputElement | Segment | null) => Segment;
export declare type GetRangeOf = ($input: HTMLInputElement | null) => {
    rawSelection: () => SelectionRange;
    cursorSegment: () => SelectionRange;
    nextSegment: () => SelectionRange;
    prevSegment: () => SelectionRange;
};
export declare type GetAncestorsOf = ($startingElem: AnyHtmlElement | null, selectorString?: string) => Array<AnyHtmlElement>;
