var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { getKeys } from '../../helpers/utils';
import { regex } from '../regex/regex';
/** Utility function for turning a node list of HTML elements into an array of HTML elements. */
export var toArray = function (arrayLikeThing) { return Array.prototype.slice.call(arrayLikeThing, 0); };
/** Utility for converting a string to a number. */
export var toNumber = function (value) {
    var number = Number(value);
    return isNaN(number) ? null : number;
};
/** Utility for adding a leading zero to single digit numbers. */
export var toLeadingZero = function (value) {
    if (value === null || value === '-')
        return '--';
    var number = Number(value);
    if (isNaN(number) && typeof value !== 'number')
        return value;
    return number < 10 ? "0" + number : "" + number;
};
/** Utility for converting a single digit 12hr time to a double digit 12hr time. */
export var toLeadingZero12HrString = function (value) {
    if (!value)
        return '--:-- --';
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    var _a = regex.lenientString12hr.exec(value) || [], _val = _a[0], hrs = _a[1], minutes = _a[2], mode = _a[3];
    return toLeadingZero(hrs) + ":" + toLeadingZero(minutes) + " " + toLeadingZero(mode);
};
/** Utility for checking if 2 time objects match. */
export var matchesTimeObject = function (timeObjA, timeObjB) {
    var keys = getKeys(__assign(__assign({}, timeObjA), timeObjB));
    return keys.every(function (k) { return timeObjA[k] === timeObjB[k]; });
};
