(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../types/Window"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.supportsTime = void 0;
    var Window_1 = require("../types/Window");
    // This is intentionally separate from index.ts since it needs to be downloaded in modern browsers
    // https://stackoverflow.com/a/10199306/1611058
    function get_time_support() {
        var input = Window_1.doc === null || Window_1.doc === void 0 ? void 0 : Window_1.doc.createElement('input');
        if (!input) {
            return false;
        }
        input.setAttribute('type', 'time');
        var notValid = 'not-a-time';
        input.setAttribute('value', notValid);
        return input.value !== notValid;
    }
    var supportsTime = get_time_support();
    exports.supportsTime = supportsTime;
    if (Window_1.win) {
        Window_1.win.supportsTime = supportsTime;
    }
    exports.default = supportsTime;
});
