(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../convert/convert"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.flash24hrTime = void 0;
    var convert_1 = require("../convert/convert");
    // Used for quickly switching an input from 12hr to 24hr then back to 12hr.
    // This is useful when the user submits forms.
    // It will sends 24hr time to the server on submit like modern browsers do.
    // Not adding a form event listener, different frameworks might handle submit differently
    /** Briefly switch an input element to display 24 hour time instead of 12 hour time. Primarily useful when submitting forms. */
    exports.flash24hrTime = function ($input) {
        var value12hr = $input.value;
        $input.value = convert_1.convertString12hr(value12hr).to24hr();
        setTimeout(function () {
            $input.value = value12hr;
        });
    };
});
