import { IsAmHrs24, IsAmString12hr, IsAmString24hr, IsAmTimeObject, IsCompleteTimeObject, IsPmHrs24, IsPmString12hr, IsPmString24hr, IsPmTimeObject, IsShiftHeldDown, IsString12hr, IsString24hr, IsTimeObject } from './is.types';
/** Retrieve the current state of the `[shift]` key. (Warning: will fail if bubbling is prevented) */
export declare let isShiftHeldDown: IsShiftHeldDown;
/** Check if a 24hr hours value is a PM value. */
export declare const isPmHrs24: IsPmHrs24;
/** Check if a 12hr string value is a PM value. */
export declare const isPmString12hr: IsPmString12hr;
/** Check if a 24hr string value is a PM value. */
export declare const isPmString24hr: IsPmString24hr;
/** Check if a time object is a PM value. */
export declare const isPmTimeObject: IsPmTimeObject;
/** Check if a 24hr hours value is an AM value. */
export declare const isAmHrs24: IsAmHrs24;
/** Check if a 12hr string value is a AM value. */
export declare const isAmString12hr: IsAmString12hr;
/** Check if a 24hr string value is a AM value. */
export declare const isAmString24hr: IsAmString24hr;
/** Check if a time object is a AM value. */
export declare const isAmTimeObject: IsAmTimeObject;
/** Check if a value is a time object */
export declare const isTimeObject: IsTimeObject;
/** Check if a time object has no null any values. */
export declare const isCompleteTimeObject: IsCompleteTimeObject;
/** Check if a value is in a 12hr string format. */
export declare const isString12hr: IsString12hr;
/** Check if a value is in a 24hr string format. */
export declare const isString24hr: IsString24hr;
