var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../helpers/utils", "../regex/regex"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.matchesTimeObject = exports.toLeadingZero12HrString = exports.toLeadingZero = exports.toNumber = exports.toArray = void 0;
    var utils_1 = require("../../helpers/utils");
    var regex_1 = require("../regex/regex");
    /** Utility function for turning a node list of HTML elements into an array of HTML elements. */
    exports.toArray = function (arrayLikeThing) { return Array.prototype.slice.call(arrayLikeThing, 0); };
    /** Utility for converting a string to a number. */
    exports.toNumber = function (value) {
        var number = Number(value);
        return isNaN(number) ? null : number;
    };
    /** Utility for adding a leading zero to single digit numbers. */
    exports.toLeadingZero = function (value) {
        if (value === null || value === '-')
            return '--';
        var number = Number(value);
        if (isNaN(number) && typeof value !== 'number')
            return value;
        return number < 10 ? "0" + number : "" + number;
    };
    /** Utility for converting a single digit 12hr time to a double digit 12hr time. */
    exports.toLeadingZero12HrString = function (value) {
        if (!value)
            return '--:-- --';
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        var _a = regex_1.regex.lenientString12hr.exec(value) || [], _val = _a[0], hrs = _a[1], minutes = _a[2], mode = _a[3];
        return exports.toLeadingZero(hrs) + ":" + exports.toLeadingZero(minutes) + " " + exports.toLeadingZero(mode);
    };
    /** Utility for checking if 2 time objects match. */
    exports.matchesTimeObject = function (timeObjA, timeObjB) {
        var keys = utils_1.getKeys(__assign(__assign({}, timeObjA), timeObjB));
        return keys.every(function (k) { return timeObjA[k] === timeObjB[k]; });
    };
});
