(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../core/convert/convert", "../core/is/is", "../core/utils/utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CurrentDate = void 0;
    var convert_1 = require("../core/convert/convert");
    var is_1 = require("../core/is/is");
    var utils_1 = require("../core/utils/utils");
    var CurrentDate = /** @class */ (function () {
        function CurrentDate() {
            var date = new Date();
            var current24hrs = date.getHours();
            this.hrs24 = utils_1.toLeadingZero(current24hrs);
            this.hrs12 = utils_1.toLeadingZero(convert_1.convertHours24(current24hrs).toHours12());
            this.minutes = utils_1.toLeadingZero(convert_1.convertDateObject(date).toTimeObject().minutes);
            this.mode = (is_1.isAmHrs24(current24hrs) ? 'AM' : 'PM');
            this.date = date;
            this.string24hr = convert_1.convertDateObject(date).to24hr();
            this.string12hr = convert_1.convertDateObject(date).to12hr();
            this.timeObject = convert_1.convertDateObject(date).toTimeObject();
        }
        CurrentDate.prototype.reInitialize = function () {
            var date = new Date();
            var current24hrs = date.getHours();
            this.hrs24 = utils_1.toLeadingZero(current24hrs);
            this.hrs12 = utils_1.toLeadingZero(convert_1.convertHours24(current24hrs).toHours12());
            this.minutes = utils_1.toLeadingZero(convert_1.convertDateObject(date).toTimeObject().minutes);
            this.mode = (is_1.isAmHrs24(current24hrs) ? 'AM' : 'PM');
            this.date = date;
            this.string24hr = convert_1.convertDateObject(date).to24hr();
            this.string12hr = convert_1.convertDateObject(date).to12hr();
            this.timeObject = convert_1.convertDateObject(date).toTimeObject();
        };
        return CurrentDate;
    }());
    exports.CurrentDate = CurrentDate;
});
